// custom code that overwrites window.fetch()
// (c) 2022 Valentin Schmidt
window.fetch = function(uri)
{
	if (typeof(uri) == 'object')
		uri = uri.url;

	console.log('[local fetch] loading:', uri);

	let mt;
	return new Promise(
		function(resolve, reject)
		{
			let xhr = new XMLHttpRequest();
			if (uri.endsWith('.json'))
			{
				xhr.responseType = 'json';
			}
			else if (uri.startsWith('blob:'))
			{
				xhr.responseType = 'blob';
			}
			else if (uri.endsWith('.jpg') || uri.endsWith('.jpeg'))
			{
				xhr.responseType = 'blob';
				mt = 'image/jpeg';
			}
			else if (uri.endsWith('.png'))
			{
				xhr.responseType = 'blob';
				mt = 'image/png';
			}
			else if (uri.endsWith('.js'))
			{
				xhr.responseType = 'text';
				mt = 'application/javascript';
			}
			else if (uri.endsWith('.obj') || uri.endsWith('.mtl') || uri.endsWith('.gltf'))
			{
				xhr.responseType = 'text';
				mt = 'text/plain';
			}
		 	else
		 	{
		 		xhr.responseType = 'arraybuffer';
		 	}

		 	if (mt) xhr.overrideMimeType(mt);

			xhr.open('GET', uri, true);
			xhr.onreadystatechange = function()
			{
				if (xhr.readyState == 4)
				{
					if (xhr.response)
					{
						let res = {'status':200, 'ok':true};
						res.headers = {get: function(h){return mt;}};
						res[xhr.responseType] = function(){return xhr.response;};
						res['arrayBuffer'] = function(){return xhr.response;};
						resolve(res);
					}
					else
						reject('Failed to load ' + uri);
				}
			};
			xhr.send(null);
		}
	);
};
